/*******************************************************************************
  MPLAB Harmony Application Source File
  
  Company:
    Microchip Technology Inc.
  
  File Name:
    app.c

  Summary:
    This file contains the source code for the MPLAB Harmony application.

  Description:
    This file contains the source code for the MPLAB Harmony application.  It 
    implements the logic of the application's state machine and it may call 
    API routines of other MPLAB Harmony modules in the system, such as drivers,
    system services, and middleware.  However, it does not call any of the
    system interfaces (such as the "Initialize" and "Tasks" functions) of any of
    the modules in the system or make any assumptions about when those functions
    are called.  That is the responsibility of the configuration-specific system
    files.
 *******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
// DOM-IGNORE-END


// *****************************************************************************
// *****************************************************************************
// Section: Included Files 
// *****************************************************************************
// *****************************************************************************

#include <proc/p32mz2048efh100.h>
#include "app.h"

#include "mrx_VS1063.h"
#include "lcd_ACM1602_lib_i2c.h"
#include "Rtc_RX8025_i2c.h"
#include "stdio.h"

char Buf[64];
char Buf1[64];
int delay_Clock = 200000000;

APP_DATA     appData;
SYS_FS_RESULT res; 
SYS_FS_HANDLE ys_fileHandle;
bool Flag_SdConnected; 

static DISK_FILE_NODE rootNode;
static DISK_FILE_PATH FilesTable[DISK_MAX_FILES];
SYS_FS_FSTAT ys_dirstat;
SYS_FS_HANDLE ys_dirHandle;

char str_FileName[64];  //t@C
char rec_FileName[64];
unsigned char FileBuf[4096];
size_t Num_Read;
int totalFiles;
int Num_File; 
int Num_File2 = -1;
const char *fname;

SYS_FS_FSTAT fileStat1;
SYS_FS_TIME time1;  
int Year1, Month1, Day1,Hour1, Min1, Sec1;

bool Flag_Pause;    //tꎞ~tO
bool Flag_Skip;     //tȃXLbvtO
bool Flag_Record;      //^Jn/~tO
int Flag_PlayBack_RecFile; //^t@CĐ/XLbv
bool Flag_RecFinalize;  //^I

bool PatcheUse;     //VS1063aGR[_pb`@gpFtrue@gpFfalse

char temp_Name[] = "temp_Name.mp3";     //̃t@C    //^IɎɊ֘At@C𖽖
char str_FileName[64];  //t@C

unsigned char recBuf[8192];
unsigned char *rbp;
unsigned int fileSize = 0;
int wordNum;
unsigned short int val;
 
char SUN[] = "SUN";
char MON[] = "MON";
char TUE[] = "TUE";
char WED[] = "WED";
char THU[] = "THU";
char FRI[] = "FRI";
char SAT[] = "SAT";
char* str;

int TimeSetMode2;    //0: t\[hA1: tݒ胂[h
int ItemSelectMode; //ݒΏہ@0F񌅁A1FA2FA3FA4FA5Fb
extern unsigned char Reg_RTC[16];  //RTC8025̃WX^liBCDlj
int Month,Day,Week,Hour,Min,Sec;
int Year;   //4̐
int Day_total,Day_Year,Day_This_Year;
int Day1,Day2,Day3,Day4,Day5,Day6,Day7,Day8,Day9,Day10,Day11,Day12;   //YearN̂PPe܂ł̓݌v

SYS_FS_RESULT resDir;
SYS_FS_TIME time;

static DISK_FILE_PATH FilesTable2[DISK_MAX_FILES];  //̃fBNg̃t@Ce[u
int totalFiles2;//̃fBNg̃g[^t@C
SYS_FS_HANDLE new_fileHandle;   //Vɐꂽt@C̃t@Cnh
char Dir_Target[] = "DIR_REC";  //̃fBNg
int Num_CreateFile; //FileMake{^Őt@C̐
static DISK_FILE_PATH FilesTable2[DISK_MAX_FILES];  //̃fBNg̃t@Ce[u
SYS_FS_FSTAT ys_dirstat2;
SYS_FS_HANDLE ys_dirHandle2;

int Flag_Mode;
int Flag_Select;
int Flag_Up;
int Flag_Down;
int Flag_FileMake;


//֐̃vg^Cv錾
void delay_us(volatile unsigned int usec);
void delay_ms(volatile unsigned int msec);
void Write_Byte(char chr); 
void WriteString(const char *str); 
void ReadRTC_Time(); 
void WeekFunc(void);
void SwCheckA_Mode(void);
void SwCheckA_Select(void);
void SwCheckD_Up(void);
void SwCheckG_Down(void);
void WeekFunc(void);
void DateTimeMonitor(void);
void APP_SYSFSEventHandler(SYS_FS_EVENT event, void * eventData, uintptr_t context);
bool ys_FileType83(char *myFileName);
SYS_FS_RESULT DISK_FS_ReadDirFlat(char *lfname, uint8_t *dir_count, SYS_FS_FSTAT * dir_table, bool isRoot);
SYS_FS_RESULT dirDISK_FS_ReadDirFlat(char *lfname, uint8_t *dir_count, SYS_FS_FSTAT * dir_table, bool isRoot); 
void DISK_TraverseAllFiles(DISK_FILE_NODE node, bool isRoot,uint8_t depth);
void Dir_Search(void);   
void APP_SdTasks (void);


void delay_us(volatile unsigned int usec)        //1secx
{
        volatile  int count;

        count = (int)(delay_Clock/20000000)*usec;


        do      //@at@200MH (Clock=200000000)
        {       //delay_us(1000)F1000.4sec  delay_us(100)F100.6sec  delay_us(10):10.5sec@@delay_us(1)F1.5sec
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");asm("NOP");
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");

                count--;
        }while(count != 0);
}



void delay_ms(volatile unsigned int msec)        //1msecx
{
        volatile unsigned int i;         //Fat200MH (Clock=200000000)//delay_ms(1)F 1.0006msec   delay_ms(100)F100.04msec

        for(i=0; i<msec; i++)
        delay_us(1000);
}



void SoftwareReset(void)        //\tgEFAZbg
{
    
    lcd_init();				// LCD
    lcd_cmd(0b00001100);    // J[\:OFF  uݸ:OFF
    lcd_clear();
    
    //ωHarmonyoO΍    //oOF|[gɂĂ͕ω݂ǉƁAZbgȂPICNȂ
    if(RCONbits.SWR == 0)   //dONA\tgEFAZbg sĂȂꍇ 
    { 
        lcd_cmd(0x80);          //1ڂ̐擪
        sprintf(Buf,"Soft-Reset was       ");//
        lcd_str(Buf);                   //t\
        lcd_cmd(0xC0);          //Qsڂ̐擪
        sprintf(Buf," not executed.  ");	//
        lcd_str(Buf);           // JnbZ[W1sڕ\

          
    //AbNV[PX(unlock sequence)       //AbNV[PXȂƁ@RSWRSTbits.SWRST = 1; ͓삵ȂB
    SYSKEY = 0;             // Ensure OSCCON is locked
    SYSKEY = 0xAA996655;    // Write Key1 to SYSKEY
    SYSKEY = 0x556699AA;    // Write Key2 to SYSKEY

    RSWRSTbits.SWRST = 1;       //\tgEFAZbggK    //unlock sequence̒Ŏs
                                //SOFTWARE RESET REGISTER
                                //    SWRST: Software Reset Trigger 
                                //1 = Enable software Reset event
                                //0 = No effect
    RSWRST;         //K{
    }
    
}




void Write_Byte(char chr)  //1oCgM֐
{
    PLIB_USART_TransmitterByteSend(USART_ID_4, chr); //Mobt@[1oCg݁EM   
//    U4TXREG = chr;  ////Mobt@[1oCg݁EM 


    while (!PLIB_USART_TransmitterIsEmpty(USART_ID_4));  //Mobt@[ɂȂ܂ő҂
//while(!U4STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂

}

void WriteString(const char *str)   //񑗐M֐
{
    while(*str)
    {
        Write_Byte(*str);   //f[^M
        str++;
    }
}


void SwCheckA(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
        if(PORTAbits.RA4 == 0)  //tꎞ~/tĊJ
        {
            delay_ms(20);
            if(PORTAbits.RA4 == 0)
            {
                if(Flag_Pause == 0)Flag_Pause = 1;  //tꎞ~   
                else  Flag_Pause = 0;               //tĊJ
            }
        }

    }

    //SW1 ݒ胂[h
    if(PORTAbits.RA0 == 0)  //Mode SW o
    {
        delay_ms(20);        
        if(PORTAbits.RA0 == 0)Flag_Mode = 1;
    }
        
    //SW2 ACeI[h
    if(PORTAbits.RA5 == 0)  //Select SW o  
    {
        delay_ms(20);
        if(PORTAbits.RA5 == 0)Flag_Select = 1;
    }
}




void SwCheckB(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
        if(PORTBbits.RB8 == 0)  //^Jn/~
        {
            delay_ms(20);
            if(PORTBbits.RB8 == 0)
            {
                if(Flag_Record == 0)
                {
                    Flag_Record = 1;  //^Jn
                    LATCbits.LATC14 = 1;
                   
                }   
                else
                {
                    Flag_Record = 0;               //^~
                    LATCbits.LATC14 = 0;
                    
                }
            }
        }
         
        if(PORTBbits.RB14 == 0) //^t@CփWv
        {
            delay_ms(20);
            if(PORTBbits.RB14 == 0)
            {
              if(Flag_PlayBack_RecFile == 0)
              {
                
                //^ĐȂ
                    Flag_PlayBack_RecFile = 1;    //@݉tt@CXLbv@@̘^t@CĐ
                    WriteString("\r\n\r\n");
                    WriteString("***** Playback VoiceRecoder Sounds !! *****\r\n");
                    LATFbits.LATF4 = 1;
                    LATFbits.LATF5 = 1;
                }
                else
                {
                    Flag_PlayBack_RecFile = 0;
                    LATFbits.LATF4 = 0;
                    LATFbits.LATF5 = 0;
                }
            }
        }    
    }
}


void SwCheckD(void)  //SW NbNo
{
    //SW3@lAbv[h
    if(PORTDbits.RD5 == 0)  //Up SW o
    {
        delay_ms(20);
        if(PORTDbits.RD5 == 0)Flag_Up = 1;
    } 
}


void SwCheckG(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
       
        if(PORTGbits.RG15 == 0) //tȃXLbv
        {
            delay_ms(20);
            if(PORTGbits.RG15 == 0)
            {
                Flag_Skip = 1;    //tȃXLbv
                
            }
        }
 
    }
    
    //SW4 l_E[h
    if(PORTGbits.RG6 == 0)  //
    {
        delay_ms(20);
        if(PORTGbits.RG6 == 0)Flag_Down = 1;
    }
}


void SwCheckA_Mode(void)  //Mode SW NbNo
{ 
    int year20XX;
    
     Flag_Mode = 0;
    if(TimeSetMode2 == 0)   
    {
        LATBbits.LATB5 = 1;
        TimeSetMode2 = 1;   //ݒ胂[h
    }
    else
    {   
        LATBbits.LATB5 = 0;
        TimeSetMode2 = 0;   //\[h
     
        year20XX = Year - 2000;
        RX8025_Reset_i2C();
        RX8025_RTC_Init(year20XX,Month,Day,Week,Hour,Min,Sec);     //ݒ肵lRTCɏ   //Year͐4ł̂2000Zēnj
    }   
}


void SwCheckA_Select(void)  //Select SW NbNo
{
     Flag_Select = 0;
    if(ItemSelectMode == 0)ItemSelectMode = 1;                          //Nݒ胂[h̏ꍇ@@ݒ胂[h
    else if(ItemSelectMode == 1)ItemSelectMode = 2;                     //ݒ胂[h̏ꍇ@@ݒ胂[h
    else if(ItemSelectMode == 2)ItemSelectMode = 3;                     //ݒ胂[h̏ꍇ@@ݒ胂[h
    else if(ItemSelectMode == 3)ItemSelectMode = 4;                     //ݒ胂[h̏ꍇ@@ݒ胂[h
    else if(ItemSelectMode == 4)ItemSelectMode = 5;                     //ݒ胂[h̏ꍇ@@bݒ胂[h
    else ItemSelectMode = 0;                                        //bݒ胂[h̏ꍇ@@Nݒ胂[h
}
 


void SwCheckD_Up(void)  //Up SW NbNo
{
    Flag_Up = 0;
    if(ItemSelectMode == 0)                 //Nݒ胂[h̏ꍇ
    {                                       //ݒ͈́i2@20-99)
        Year++;             
        if(Year >= 2099)Year = 2099;
    }
    else if(ItemSelectMode == 1)            //ݒ胂[h̏ꍇ@
    {
        Month++;
        if(Month >= 12)Month = 12;
    }
    else if(ItemSelectMode == 2)            //ݒ胂[h̏ꍇ@
    {
        Day++;
        if( (Month == 4) || (Month == 6) ||     //4A6A9A11̏ꍇ 
            (Month == 9) || (Month == 11) )
        {   
            if(Day >= 31)Day = 30;
        }
        else if(Month == 2)                     //2̏ꍇ
        {
            //邤N̏ꍇ
            if((Year % 4 == 0) && (Year % 100 != 0))    //100Ŋ؂ȂłSŊ鐼N͂邤NłB
            {
                if(Day >=30)Day = 29;
            }
            else    //邤NȊO
            {
                if(Day >=29)Day = 28;
            }
        }
        else                                    //PARATAVAWAPOAPQ̏ꍇ
        {
            if(Day >= 32)Day = 31;
        }
    }
    else if(ItemSelectMode == 3)               //ݒ̏ꍇ
    {
        Hour++;
        if(Hour >= 24)Hour = 23;
    }
    else if(ItemSelectMode == 4)                //ݒ̏ꍇ
    {
        Min++;
        if(Min >= 60)Min = 59;
    }
    else                                        //bݒ̏ꍇ
    {
        Sec++;
        if(Sec >= 60)
        {
            Sec = 59;
        }
    }
}





void SwCheckG_Down(void)  //SW NbNo
{ 
    Flag_Down = 0;
       
    if(ItemSelectMode == 0)             //Nݒ胂[h̏ꍇ@
    {                                   //ݒ͈́i2@20-99)
        Year--;
        if(Year <= 2020)Year = 2020;
    }
    else if(ItemSelectMode == 1)        //ݒ胂[h̏ꍇ
    {
        Month--;
        if(Month <= 0) Month = 1;
    }
    else if(ItemSelectMode == 2)        //ݒ胂[h̏ꍇ
    {
        Day--;
        if(Day <= 0) Day = 1;
    }
    else if(ItemSelectMode == 3)        //ݒ胂[h̏ꍇ@
    {
        Hour--;
        if(Hour <= -1)Hour = 0;
    }
    else if(ItemSelectMode == 4)        //ݒ胂[h̏ꍇ@
    {
        Min--;
        if(Min <= -1)Min = 0;
    }
    else                                //bݒ胂[h̏ꍇ
    {
        Sec--;
        if(Sec <= -1)
        {
            Sec = 0;
        }
    }  
}






void ReadRTC_Time() //RTC̎ǂݏo 
{
    int year20XX;
    
    //WX^l@ꊇǂݏo            
    RX8025_Read_AllReg(&Reg_RTC[0]);
    if((RX8025_BCDToBinary(Reg_RTC[6]) >= 100) ||  //2AtAۑĂȂꍇ  2020N11ij00F00F00\
        (RX8025_BCDToBinary(Reg_RTC[5]) >= 13) ||  //
        (RX8025_BCDToBinary(Reg_RTC[4]) >= 32) ||  //
        (RX8025_BCDToBinary(Reg_RTC[2]) >= 25) ||  // 
        (RX8025_BCDToBinary(Reg_RTC[1]) >= 60) ||  //     
        (RX8025_BCDToBinary(Reg_RTC[0]) >= 60))    //b      
    {
        Year = 2020; 
        Month = 1; 
        Day = 1; 
        WeekFunc(); //j̎Zo
    
        year20XX = Year - 2000;   //Year͐4ł̂ŁARTCɏޏꍇ2000Zēn
        RX8025_RTC_Init(year20XX,Month,Day,Week,0,0,0);     //2020/1/1 @00F00:00 
    }
    else
    {
        Sec = RX8025_BCDToBinary(Reg_RTC[0]); //DCD10iɕϊ
        Min = RX8025_BCDToBinary(Reg_RTC[1]);
        Hour = RX8025_BCDToBinary(Reg_RTC[2]);
        Week = RX8025_BCDToBinary(Reg_RTC[3]);
        Day = RX8025_BCDToBinary(Reg_RTC[4]);
        Month = RX8025_BCDToBinary(Reg_RTC[5]);
        Year = RX8025_BCDToBinary(Reg_RTC[6]) + 2000;      //RTCǂݍ܂l͐̉2ł̂Ł@2000ZB
    }
}




void WeekFunc(void) //NjZo֐
{
    int i,Year1,Day_Feb,Weekx;

    // 2000N(Year -1)N܂ł̓vZ-----------------------------------------------------
    Day_Year = 0;
    for(i = 2000; i < Year; i++)    
    {
        if(((i % 4) == 0) && (!(i % 100) == 0))     //OSI  //100Ŋ؂ȂłSŊ鐼N͂邤NłB
        {
            Year1 = 366;
        }
        else Year1 = 365;

        Day_Year = Day_Year + Year1;
    }
        
    //YearN̗݌vvZ-----------------------------------------------------------------------
            //Q̓vZ

        if(((i % 4) == 0) && (!(i % 100) == 0))     //OSI  //100Ŋ؂ȂłSŊ鐼N͂邤NłB
        {
            Day_Feb = 29;
        }
        else Day_Feb = 28;

        Day1  = Day;
        Day2  = Day1 + 31;
        Day3  = Day2 + Day_Feb;
        Day4  = Day3 + 31;
        Day5  = Day4 + 30;
        Day6  = Day5 + 31;
        Day7  = Day6 + 30;
        Day8  = Day7 + 31;
        Day9  = Day8 + 31;
        Day10 = Day9 + 30;
        Day11 = Day10 + 31;
        Day12 = Day11 + 30;

    switch(Month)
    {
        case 1:                     //P̏ꍇ
            Day_This_Year = Day1;
            break;
        case 2:                     //Q̏ꍇ
            Day_This_Year = Day2;
            break;
        case 3:
            Day_This_Year = Day3;   //Ȑꍇ
            break;
        case 4:
            Day_This_Year = Day4;   //S̏ꍇ
            break;
        case 5:
            Day_This_Year = Day5;   //T̏ꍇ
            break;
        case 6:
            Day_This_Year = Day6;   //Ȕꍇ
            break;
        case 7:
            Day_This_Year = Day7;   //V̏ꍇ
            break;
        case 8:
            Day_This_Year = Day8;   //W̏ꍇ
            break;
        case 9:
            Day_This_Year = Day9;   //X̏ꍇ
            break;
        case 10: 
            Day_This_Year = Day10;  //PȌꍇ
            break;
        case 11:
            Day_This_Year = Day11;  //PP̏ꍇ
            break;
        case 12:
            Day_This_Year = Day12;  //PQ̏ꍇ
            break;
        default: break;
    }

    //2000NPPiyj YearNMothDayԂł̗݌vDay_total ----------------------------------------
    Day_total = Day_This_Year + Day_Year;
            //@YearN̗݌v@{@2000N11@i@Year - PjN1231܂ł̓݌v
    Weekx = (unsigned long int)( Day_total % 7);

    switch(Weekx)
    {
        case 0:     //yj
            Week = 6;   break;
        case 1:     //j
            Week = 0;   break;
        case 2:     //j
            Week = 1;   break;
        case 3:     //Ηj
            Week = 2;   break;
        case 4:     //j
            Week = 3;   break;
        case 5:     //ؗj
            Week = 4;   break;
        case 6:     //j
            Week = 5;   break;
        default: break;
    }
}


void DateTimeMonitor(void)
  {      
            if(Flag_Mode == 1)SwCheckA_Mode();
            if(Flag_Select == 1)SwCheckA_Select();  //ݒACeIccNAAAAAb
            if(Flag_Up == 1)SwCheckD_Up();
            if(Flag_Down == 1)SwCheckG_Down();
            
            WeekFunc();     //ݒ肵NjZo
            switch(Week)
            {
                case 0: str = SUN;  break;
                case 1: str = MON;  break;
                case 2: str = TUE;  break;
                case 3: str = WED;  break;
                case 4: str = THU;  break;
                case 5: str = FRI;  break;
                case 6: str = SAT;  break;
                default:            break;
            }
            

            if(TimeSetMode2 == 0)    //t\[h̏ꍇ
            {
                ReadRTC_Time();     //RTC̎ǂݏo 
                sprintf(Buf1,"");   //ݒύXڂ\
            }
            else    //tݒ胂[h̏ꍇ  
            {
                switch(ItemSelectMode)
                {
                    case 0: sprintf(Buf1,"(Year)");  break;
                    case 1: sprintf(Buf1,"(Mon)");  break;
                    case 2: sprintf(Buf1,"(Day)");   break;
                    case 3: sprintf(Buf1,"(Hour)");  break;
                    case 4: sprintf(Buf1,"(Min)");   break;
                    case 5: sprintf(Buf1,"(Sec)");   break;
                }
            }    
            
            
                
            lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
            sprintf(Buf,"%04d/%02d/%02d %s    ",Year,Month,Day,str);
            lcd_ACM1602_str_i2c(Buf);
            lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
            sprintf(Buf,"%02d:%02d:%02d %s          ",Hour,Min,Sec,Buf1);
            lcd_ACM1602_str_i2c(Buf);
                
           
        }



void APP_SYSFSEventHandler(SYS_FS_EVENT event, void * eventData, uintptr_t context) //SDJ[h̃}EgL𒲂ׂR[obN֐
{
    switch(event)
    {
        /* If the event is mount then check which media has been mounted */
        case SYS_FS_EVENT_MOUNT: 
            if(0 == strcmp((const char *)eventData,"/mnt/myDrive1"))
            {
                Flag_SdConnected = true;
            }

            break;
        /* If the event is unmount then check which media has been unmount */
        case SYS_FS_EVENT_UNMOUNT:
            if(0 == strcmp((const char *)eventData,"/mnt/myDrive1"))
            {
                Flag_SdConnected = false;
            }

            break;
            
        case SYS_FS_EVENT_ERROR:
            break; 
            
        default:
            break;
    }
}






bool ys_FileType83(char *myFileName)   //8.3`t@C`FbN //8.3`Ȃtrue
{
    bool Flag;
    if((myFileName[0] == 0x7E) || (myFileName[1] == 0x7E) ||        //t@C ~i`_j܂܂Ăꍇ8.3`ł͂Ȃ
            (myFileName[2] == 0x7E) || (myFileName[3] == 0x7E) || 
            (myFileName[4] == 0x7E) || (myFileName[5] == 0x7E) ||
            (myFileName[6] == 0x7E) || (myFileName[7] == 0x7E)) Flag = false;   
    else Flag = true;   //t@C ~i`_j܂܂ĂȂꍇ8.3`ł

    
////@@VOI~1A83.MPGimyFileName[3] == 0x7EjƂOt@C邱Ƃ킩̂ŏLɕύX    
//@    
//    if(myFileName[6] != 0x7E) Flag = true;    //~܂܂Ȃ@@8.3`t@C 
//    else Flag = false;              //~܂܂@@Ot@C      //FMOONRI~1.mp3 
 
    return Flag;
}



//fBNg t@CXg쐬     
//DISK_FS_ReadDirFlat()̃t@Ce[u(FilesTable2)ƃg[^t@C(totalFiles2)ύXłB
SYS_FS_RESULT dirDISK_FS_ReadDirFlat(char *lfname,         //ŒfBNg̃tpXւ̃|C^
                                                            //Œځ@lfname Dir_Target[] = "Dir_REC"nĂ̂ "DIR_REC" ɂȂȂB
                                                            //Ȃ킿ASYS_FS_DirRead()ŒTAꂽfBNgł͂Ȃ̂Ł@"DIR_REC" ɂȂȂB
                                                            //SYS_FS_DirRead()TAfBNgׂ͂đ啶ƂȂB
                                                            //AAt@C̒ɂ͏Bi啶Əʂĕ\łj
                                                            //ӁFAT̓t@CAfBNgɂׂăAt@xbg啶/̋ʂȂ啶ŊǗĂB!!
                                    uint8_t *dir_count,     //̃fBNg̒ɂqfBNg̐ւ̃|C^
                                    SYS_FS_FSTAT * dir_table,   //Ŝ̃fBNge[uւ̃|C^
                                    bool isRoot)            //̃fBNg[gfBNgł邩ۂ
{
    SYS_FS_RESULT ret;
    bool Flag83;
    char longFileName[300];
    
    ys_dirHandle2 = SYS_FS_DirOpen(lfname);  //lfname: tpX̃fBNg  //[gfBNg0
    
    if(ys_dirHandle2 == SYS_FS_HANDLE_INVALID)
    {
        return SYS_FS_RES_FAILURE;
    }
    
    *dir_count = 0;
    
   
  
    
    //do [vŁ@g[^̃t@CJEgB
    do
     {
         if(totalFiles < DISK_MAX_FILES)   //DISK_MAX_FILES = 80
         {
             ys_dirstat2.lfname = longFileName;
             ys_dirstat2.lfsize = 300;
             
             ret = SYS_FS_DirRead(ys_dirHandle2,&ys_dirstat2);   //fBNgEt@C̃Xe[^Xǂݍ
                                                                //ǂݍxɁ@قȂfBNgort@Cǂݍ
                                                                //͍\SYS_FS_FSTAT̃IuWFNgys_dirstatɂ
             if(ret == SYS_FS_RES_FAILURE )
             {
                  WriteString("\r\nSYS_FS_DirRead: failed ");
             }

            
             if ((ys_dirstat2.lfname[0] == '\0') && (ys_dirstat2.fname[0] == '\0'))   //fBNg̏I[ɒBꍇAŔ
             {
                 break;
             }
             
             if(ret!= SYS_FS_RES_FAILURE)   //ǂݍݐȂ
             {
                 if(ys_dirstat2.fattrib != SYS_FS_ATTR_DIR)    // fBNgłȂꍇ  //SYS_FS_ATTR_DIR: fBNg
                 {
                        Flag83 = ys_FileType83(ys_dirstat2.fname);
                        // 8.3`t@C̏ꍇ
                        if(Flag83 == true)      
                        {
                            strcpy(FilesTable2[totalFiles2].path, lfname);    //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable2[totalFiles2].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable2[totalFiles2].path, ys_dirstat2.fname);
                            (totalFiles2)++;
                        }
                        // Ot@C̃t@C̏ꍇ
                        else if(Flag83 != true)   
                        {
                            strcpy(FilesTable2[totalFiles2].path, lfname); //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable2[totalFiles2].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable2[totalFiles2].path, ys_dirstat2.lfname);
                            (totalFiles2)++; 
                        } 
                     
                    }
                    // fBNg̏ꍇ
                    else if(ys_dirstat2.fattrib == SYS_FS_ATTR_DIR && ys_dirstat2.fname[0] != '.') // Skip ".\" and "..\" directories
                    {
//                            
//                            if(*dir_count < DISK_MAX_DIRS)
//                            {
//                                dir_table[*dir_count]= ys_dirstat;
//                                (*dir_count)++;
//                            }
                    }
                
            }
            else
            {
                ret = SYS_FS_RES_FAILURE;
                break;
            }
        }
    }while(ret==SYS_FS_RES_SUCCESS);
     
    ret = SYS_FS_DirClose(ys_dirHandle2);
    
    return ret;    

}






//t@CXg쐬
SYS_FS_RESULT DISK_FS_ReadDirFlat(char *lfname, uint8_t *dir_count, SYS_FS_FSTAT * dir_table, bool isRoot)
{
    SYS_FS_RESULT ret;
    bool Flag83;
    char longFileName[300];
    
    ys_dirHandle = SYS_FS_DirOpen(lfname);  //lfname: tpX̃fBNg  //[gfBNg0
    
    if(ys_dirHandle == SYS_FS_HANDLE_INVALID)
    {
        return SYS_FS_RES_FAILURE;
    }
    *dir_count = 0;
    
    //do [vŁ@g[^̃t@CJEgB
    do
     {
         if(totalFiles < DISK_MAX_FILES)   //DISK_MAX_FILES = 80
         {
             ys_dirstat.lfname = longFileName;
             ys_dirstat.lfsize = 300;
             
             ret = SYS_FS_DirRead(ys_dirHandle,&ys_dirstat);   //fBNgEt@C̃Xe[^Xǂݍ
                                                                //ǂݍxɁ@قȂfBNgort@Cǂݍ
                                                                //͍\SYS_FS_FSTAT̃IuWFNgys_dirstatɂ
             if ((ys_dirstat.lfname[0] == '\0') && (ys_dirstat.fname[0] == '\0'))   //fBNg̏I[ɒBꍇAŔ
             {
                 break;
             }
             if(ret!= SYS_FS_RES_FAILURE)   //ǂݍݐȂ
             {

                 if(ys_dirstat.fattrib != SYS_FS_ATTR_DIR)    // fBNgłȂꍇ  //SYS_FS_ATTR_DIR: fBNg
                 {
                        Flag83 = ys_FileType83(ys_dirstat.fname);
                        // 8.3`t@C̏ꍇ
                        if(Flag83 == true)      
                        {
                            strcpy(FilesTable[totalFiles].path, lfname);    //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable[totalFiles].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable[totalFiles].path, ys_dirstat.fname);
                        
                            (totalFiles)++;
                            
                            
                        }
                        // Ot@C̃t@C̏ꍇ
                        else if(Flag83 != true)   
                        {
                            strcpy(FilesTable[totalFiles].path, lfname); //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable[totalFiles].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable[totalFiles].path, ys_dirstat.lfname);
                        
                            (totalFiles)++;    
                          
                        } 
                     
                    }
                    // fBNg̏ꍇ
                     else if(ys_dirstat.fattrib == SYS_FS_ATTR_DIR && ys_dirstat.fname[0] != '.') // Skip ".\" and "..\" directories
                    {
                            
                            if(*dir_count < DISK_MAX_DIRS)
                            {
                                dir_table[*dir_count]= ys_dirstat;
                                (*dir_count)++;
                            }
                    }
                
            }
            else
            {
                ret = SYS_FS_RES_FAILURE;
                break;
            }
        }
    }while(ret==SYS_FS_RES_SUCCESS);
     
    SYS_FS_DirClose(ys_dirHandle);
    return ret;    

}



void DISK_TraverseAllFiles(DISK_FILE_NODE node, bool isRoot,uint8_t depth)  //St@Cڍג֐    //ċA֐
{ 
     if(depth > TRAVERSE_DEPTH)     //fBNg̍ő[    //5
     {
         return;
     }
     int i;
     SYS_FS_RESULT ret;

     uint8_t totalDir = 0;
     SYS_FS_FSTAT dirTable[DISK_MAX_DIRS];
     
     ret = DISK_FS_ReadDirFlat(node.path, &totalDir, dirTable, isRoot);     //

     if(ret == SYS_FS_RES_FAILURE)
     {
         return;
     }

     DISK_FILE_NODE child_node;
     
     for(i = 0; i < totalDir; i++)
     {
         
         child_node.fstat = dirTable[i];
         
         strcpy(child_node.path, node.path);
         if(!isRoot)
         {
             strcat(child_node.path, "/");
         }
         strcat(child_node.path, child_node.fstat.fname);
         
    //-----̂ŌĂ΂Ă
         DISK_TraverseAllFiles(child_node, false, depth+1); //ċA
         
     }
     
     return;
 }


void Dir_Search(void)//̃fBNg̃t@C   
{
                uint8_t totalDir2 = 0;
                SYS_FS_FSTAT dirTable2[DISK_MAX_DIRS];
                //̃fBNg
                dirDISK_FS_ReadDirFlat(Dir_Target, &totalDir2, dirTable2, 0);     // Dir_TargetfBNg̑St@CASt@C 
}




void APP_SdTasks (void)
{
    int i;
    int strCheck;   //v0
    
    
    switch ( appData.state )
    {
            
        case APP_DISK_SCANNING:   //XLs

            
            DISK_TraverseAllFiles(rootNode, true, 0);   //[gSt@Cڍׂɒ   //ċA֐
            
            if(totalFiles == 0)
            {
             
                // No File
                appData.state = APP_DISK_SCANNING;
            }
            else
            {    
                lcd_cmd(0x80);          //1ڂ̐擪
                sprintf(Buf,"TotalFile=%d              ", (totalFiles - 1));	//FilesTable[0].path́ASystem Volume Information
                lcd_str(Buf);           // JnbZ[W1sڕ\
                
                lcd_cmd(0xC0);          //2sڂ̐擪
                sprintf(Buf,"                            ");	//
                lcd_str(Buf);           // JnbZ[W1sڕ\
                
                //Tera TermɑSt@C\
                sprintf(Buf,"--- SD card: TotalFile=%d\r\n", (totalFiles - 1));
                WriteString(Buf);   
    
                delay_ms(2000);
                
                //Tera TermɑSt@C̃t@CtpXtŕ\
                
                for (i = 1; i < totalFiles; i++ )
                {
                    sprintf(Buf,"%s   ",FilesTable[i].path);
                    WriteString(Buf);
                    
                    SYS_FS_FileStat(FilesTable[i].path, &fileStat1);
                    time1.timeDate.time = fileStat1.ftime;
                    time1.timeDate.date = fileStat1.fdate;
                    
                    Year1 = time1.discreteTime.year;
                    Month1 = time1.discreteTime.month;
                    Day1 = time1.discreteTime.day;
                    Hour1 = time1.discreteTime.hour;
                    Min1 = time1.discreteTime.minute; 
                    Sec1 = time1.discreteTime.second; 
                    
                    sprintf(Buf,"%d/%02d/%02d  %02d:%02d:%02d\r\n",Year1 + 1980,Month1,Day1,Hour1,Min1,Sec1);
                    WriteString(Buf);
                }
                
                Dir_Search();   //^fBNgt@C@TAe[u쐬A\
                
                            
                //LN^t\
                lcd_cmd(0x80);          //1ڂ̐擪
                sprintf(Buf,"TotalFile2=%d              ", totalFiles2);	//FilesTable[0].path́ASystem Volume Information
                lcd_str(Buf);           // JnbZ[W1sڕ\
                lcd_cmd(0xC0);          //2sڂ̐擪
                sprintf(Buf,"                            ");	//
                lcd_str(Buf);           // JnbZ[W1sڕ\
                
                //Tera TermɑSt@C\
                WriteString("\r\n");
                sprintf(Buf,"--- DIR_REC: TotalFile=%d\r\n", totalFiles2);
                WriteString(Buf); 
                
                //Tera TermɑSt@C̃t@CtpXtŕ\
                for (i = 0; i < totalFiles2; i++ )
                {
                    sprintf(Buf,"%s   ",FilesTable2[i].path);   //FilesTable[i].pathFtpXtt@C
                    WriteString(Buf);
                    
                    SYS_FS_FileStat(FilesTable2[i].path, &fileStat1);
                    time1.timeDate.time = fileStat1.ftime;
                    time1.timeDate.date = fileStat1.fdate;
                    
                    Year1 = time1.discreteTime.year;
                    Month1 = time1.discreteTime.month;
                    Day1 = time1.discreteTime.day;
                    Hour1 = time1.discreteTime.hour;
                    Min1 = time1.discreteTime.minute; 
                    Sec1 = time1.discreteTime.second; 
                    
                    sprintf(Buf,"%d/%02d/%02d  %02d:%02d:%02d\r\n",Year1 + 1980,Month1,Day1,Hour1,Min1,Sec1);
                    WriteString(Buf);
                    
                }
                WriteString("\r\n\r\n");
                WriteString("***** Playback Sounds !! *****\r\n");
                SYS_FS_DirectoryMake(Dir_Target);   //ۑfBNgȂꍇ͐
                Num_File = 1;   //t@Ce[u No = 1 ݒ
                
                appData.state = APP_OPEN_FILE;
            }
            break;
            
                
        case APP_OPEN_FILE:     //t@CJĉt
                VS1063_Init();      //K{  //ȂƃmCY at Skip Mode
            
                if(Flag_PlayBack_RecFile >= 1)
                {
                    fname = FilesTable2[Num_File2].path;  //pXtt@C擾
                }
                else
                {
                    fname = FilesTable[Num_File].path;  //pXtt@C擾
                }
                
                
                ys_fileHandle = SYS_FS_FileOpen(fname, (SYS_FS_FILE_OPEN_READ_PLUS));   //ǂݍ݃[hŁAt@CI[v


                if(ys_fileHandle == SYS_FS_HANDLE_INVALID)
                { //t@CI[vG[̏ꍇ
                    lcd_cmd(0x80);          //1ڂ̐擪
                    sprintf(Buf,"FileOpen failed          ");//
                    lcd_str(Buf);                   //t\
                    //while(1);
                }
                else
                {
                    lcd_cmd(0x80);          //1ڂ̐擪
                    sprintf(Buf,"%s               ", fname);// 
                    lcd_str(Buf);                   //t\
                    
                    lcd_cmd(0xC0);          //Qsڂ̐擪
                    //̒ŕ\@𔻕
                    if(strlen(fname) <= 16)     //pXtt@C16ȓłꍇ
                    {
                        sprintf(Buf,"                 ");
                        lcd_str(Buf);           // JnbZ[W1sڕ\
                    }
                    else
                    {
                        sprintf(Buf,"%s                 ", fname + 16);	//FilesTable[i]̃|C^16oCgi߂
                        lcd_str(Buf);           // JnbZ[W1sڕ\
                    }
                    
                   // Tera Term֑M
                    sprintf(Buf,"%s   ", fname);
                    WriteString(Buf); 
                    
                    SYS_FS_FileStat(fname, &fileStat1);
                    time1.timeDate.time = fileStat1.ftime;
                    time1.timeDate.date = fileStat1.fdate;
                    
                    Year1 = time1.discreteTime.year;
                    Month1 = time1.discreteTime.month;
                    Day1 = time1.discreteTime.day;
                    Hour1 = time1.discreteTime.hour;
                    Min1 = time1.discreteTime.minute; 
                    Sec1 = time1.discreteTime.second; 
                    
                    sprintf(Buf,"%d/%02d/%02d  %02d:%02d:%02d\r\n",Year1 + 1980,Month1,Day1,Hour1,Min1,Sec1);
                    WriteString(Buf);
                    
                    
                    char fileName[64];
                    char Extension[8];
                    char* tempStr;
                    // WMAt@CȂXLbv
                    SYS_FS_FileNameGet(ys_fileHandle, fileName, 64 );
                    
                    tempStr = strchr(fileName, '.');    //
                    memcpy(Extension, tempStr + 1, 3);  //'.'̎3oCg؂
                    Extension[3] = '\0';    //񉻁@//̏ꍇ́ÃoCg'\0'Ȃ̂łȂĂ悢
                    sprintf(Buf, "%s",Extension);   //BufɕƂēǂݍ
                    
                    if((strcmp(Buf,"wma") == 0) || (strcmp(Buf,"WMA") == 0))
                    {
                        Flag_Skip = 1;
                        
                        WriteString("--- Above was Skipped.  Because Extension = ");
                        WriteString(Buf);
                        WriteString("\r\n\r\n");
                    }
                  
                    appData.state = APP_SEND_DATA;
                }
            break;
   
            
        case APP_SEND_DATA:     //t@CJĉt 
                do{
                    if(Flag_Pause == 1)break;   //ꎞ~̏ꍇ
                    if(Flag_Record == 1)break;  //^̏ꍇ
                    if(Flag_PlayBack_RecFile == 1)  //
                    {
                        Flag_PlayBack_RecFile = 2;
                        break;   
                    }
                    
                 


                                                 
                    if(Flag_Skip == 1)      //XLbv̏ꍇ
                    {
                        Flag_Skip = 0;
                        appData.state = APP_NEXT_FILE;  
                        break;
                    }
                    
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);  //Aportω荞݋֎~
                //    IEC3bits.CNAIE = 0;      //Aport ω荞݋֎~
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);  //Gportω荞݋֎~
                //    IEC3bits.CNGIE = 0;      //Dport ω荞݋֎~
                    IEC0bits.T1IE = 0;  //VXe^C}荞݋֎~
                    
                    VS1063_XCS = 1;			// R}hM[h@OFF
                    while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                    VS1063_DataSendOn();         // f[^M[h@ON
                    

                   //Num_Read = SYS_FS_FileRead(ys_fileHandle, FileBuf, 4096);    //݂ɂȂ  //t@CGh܂ŒBꍇ:@ǂݍݎsA-1Ԃ
                   Num_Read = SYS_FS_FileRead(ys_fileHandle, FileBuf, 2048);    //t@CGh܂ŒBꍇ:@ǂݍݎsA-1Ԃ
                   // Num_Read = SYS_FS_FileRead(ys_fileHandle, FileBuf, 1024);    //t@CGh܂ŒBꍇ:@ǂݍݎsA-1Ԃ
                   // Num_Read = SYS_FS_FileRead(ys_fileHandle, FileBuf, 512);    //Ȃ̏߂ɃTEĥ݂ꔭ  //t@CGh܂ŒBꍇ:@ǂݍݎsA-1Ԃ

                    for( i= 0; i<Num_Read; i++)
                    {
                        while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                        VS1063_SendData(FileBuf[i]);	//tf[^VS1053 M
                    }
      
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);   //Aport ω荞ݗL                            
                //    IEC3bits.CNAIE = 1;  //Aport ω荞ݗL
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);   //Gport ω荞ݗL                            
                //    IEC3bits.CNGIE = 1;  //Dport ω荞ݗL
                    IEC0bits.T1IE = 1;    //VXe^C}荞ݍĊJ
                  
                    DateTimeMonitor();  //tA̕\  //15msec

                 
            	} while(Num_Read != 0); 
               
                VS1063_DataSendOff();         // f[^M[h@OFF
                
                if(Flag_Pause == 1)appData.state = APP_STATE_IDLE;
                else if(Flag_Record == 1)appData.state = APP_STATE_RECORD;
                else appData.state = APP_NEXT_FILE;
            break;
            
            
        case APP_NEXT_FILE:
                VS1063_ResetOn();//\tgEFAZbgs
                delay_ms(50);
                VS1063_ResetOff();
                delay_ms(50);
                
                SYS_FS_FileClose(ys_fileHandle);
                if(Flag_PlayBack_RecFile == 2)  //^t@CfBNgĐ̏ꍇ
                {
                    Num_File2++;    //Dir_RECfBNg@Đt@CԍCNg 
                    if(Num_File2 >=  (totalFiles2))
                    {
                            Num_File2 = -1;     //
                            Flag_PlayBack_RecFile = 0;
                            WriteString("\r\n\r\n");
                            LATFbits.LATF4 = 0; //LED
                            LATFbits.LATF5 = 0; //LED
                    }
                }
                else
                {
                    Num_File++;     //SD@St@C̍Đt@CԍCNg
                    if(Num_File >=  (totalFiles))Num_File = 1;
                }
                appData.state = APP_OPEN_FILE;
            break;
    
            
            
                /////////////////////////////////////////////////////////////////////////////////           
                //  ^Xe[g         
                /////////////////////////////////////////////////////////////////////////////////            
          case APP_STATE_RECORD:
                ys_fileHandle = SYS_FS_FileClose(ys_fileHandle);   //t@CN[Y
                if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                {
                    sprintf(Buf,"Fileclose succeeded !\r\n\r\n"); 
                    WriteString(Buf);       //TeraTerm
                }
             
                VS1063_ResetOn();//n[hEFAZbgs
                delay_ms(100);
                VS1063_ResetOff();
                delay_ms(100); 
                
                PatcheUse = true;     //VS1063aGR[_pb`@gpFtrue@gpFfalse    
                
                //VS1063_PcmRec_Init(PatcheUse);    //kȂ jAPCM(WAVEA*.wav)  
                //VS1063_ImaRec_Init(PatcheUse);    //kR[fbN IMA ADPCM(WAVEA*.wav) 
                VS1063_Mp3Rec_Init(PatcheUse) ;     //MP3R[fbN (*.mp3) 
                
                SYS_FS_RESULT resDir;
                //^pfBNg̍쐬
                resDir = SYS_FS_DirectoryMake(Dir_Target);  //Dir_RecfBNgɑ݂Ăꍇ@
                                                            //resDirɂ́@SYS_FS_RES_FAILUREԂ邪@̌̓ɂ͉eȂB
                SYS_FS_DirectoryChange(Dir_Target);

                
                DateTimeMonitor();  //ݎ̕\    //^Jn_ł̓t^CX^v̓tƂȂ
                
                ys_fileHandle = SYS_FS_FileOpen(temp_Name, (SYS_FS_FILE_OPEN_WRITE_PLUS ));  //^pt@C𐶐
               
                SYS_FS_FileSeek(ys_fileHandle, 0, SYS_FS_SEEK_SET); //t@C|C^擪Ɉړ
       
                if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                {
                    SYS_FS_FileNameGet(ys_fileHandle, str_FileName, 64 ); //t@C擾
                    sprintf(Buf,"%s Opened !\r\n ",str_FileName); 
                    WriteString(Buf);       //TeraTerm
                    sprintf(Buf,"Start Recoding !\r\n "); 
                    WriteString(Buf);       //TeraTerm
                    
                }
                
                  VS1063_XCS = 1;               // R}hM[h@OFF
                  VS1063_XDCS = 0;              // f[^M[h@ON
                    
                rbp = &recBuf[0];
                
                do{ 
                    
                    if(Flag_Record == 0)   //^~
                    {
                        Flag_RecFinalize = 1;
                        break;
                    } 
                    
                    while(!VS1063_DREQ);		//VS1063̏҂
                    wordNum = mrxVS1063_ReadSci(SCI_HDAT1);  //obt@[ɂf[^16rbgf[^̐擾    //HDAT1WX^F0x9  
                    //wordNum = min(wordNum, 8192/2);
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);  //Aportω荞݋֎~
                //    IEC3bits.CNAIE = 0;      //Aport ω荞݋֎~                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);  //Bportω荞݋֎~
                //    IEC3bits.CNBIE = 0;       //Bport ω݋֎~
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);  //Gportω荞݋֎~
                //    IEC3bits.CNGIE = 0;      //Dport ω荞݋֎~
                    IEC0bits.T1IE = 0;  //VXe^C}荞݋֎~
                    
                    for (i=0; i< wordNum; i++)
                    {
                        while(!VS1063_DREQ);		//VS1063̏҂
                        val = mrxVS1063_ReadSci(SCI_HDAT0);	//P16bit f[^擾    //SCI_HDAT0WX^(0x08)
                        *rbp++ = (unsigned char)(val >> 8);
                        *rbp++ = (unsigned char)(val & 0xFF);
                    }
                    while(!VS1063_DREQ);		//VS1063̏҂
                    SYS_FS_FileWrite(ys_fileHandle, &recBuf[0], 2*wordNum);//2 x wordNumoCg: recBufɂl(2 x wordNum)oCgt@C̖ɒǋL
                    fileSize += 2*wordNum;     //ǉf[^ioCgjt@CTCYɉZ
                     
                    rbp = &recBuf[0];   //obt@NA
                    
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);   //Aport ω荞ݗL                            
                    //IEC3bits.CNAIE = 1;  //Aport ω荞ݗL
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);   //Bport ω荞ݗL 
                    //IEC3bits.CNBIE = 1;   //Bport ωݗL    
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);   //Gport ω荞ݗL                            
                    //IEC3bits.CNGIE = 1;  //Dport ω荞ݗL
                    IEC0bits.T1IE = 1;    //VXe^C}荞ݍĊJ
                    
                    
                    
                  }while(fileSize < 100000000);  //MAX 100MoCg   //^őt@CTCY𐧌
                    Flag_RecFinalize = 1;
                    
                    if(Flag_RecFinalize == 1)   //^I
                    {
                        LATCbits.LATC14 = 0;
                        
                        while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                        mrxVS1063_WriteSci(SCI_MODE, mrxVS1063_ReadSci(SCI_MODE) | SM_CANCEL);    //VS1063_WriteSci(SCI_MODE, SM_SDINEW | SM_CANCEL);    //SM_CANCEL: 0x0008
                                           
                        delay_ms(500);

                        //t@C̏ꍇɕύXKv
                        while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                        unsigned short int value0 = mrxVS1063_ReadWram(0x1e06);	//RAḾ@0x1e06AhXɂlǂݏo //#define PAR_END_FILL_BYTE 0x1e06
                        if (value0 & 0x8000)
                        {
                            unsigned char temp1 = value0 & 0xFF;
                            SYS_FS_FileWrite(ys_fileHandle, &temp1, 1); //t@C1oCgǉ
                        }
                        
                          //WAVE/RFFt@Ĉ
//                        //t@Cwb_[Ƀ`N
//                        ChunkSize = fileSize - 8;  //ItZbg0x04ɏޒl
//                        sprintf(Buf,"fSize-8=0x%X\r\n", fileSize - 8); 
//                        WriteString(Buf);       //TeraTerm
//                        
//                        SYS_FS_FileSeek(ys_fileHandle, 4, SYS_FS_SEEK_SET); //t@C|C^̈ʒut@C擪4(0x04)oCgItZbgʒuɈړ
//                        SYS_FS_FileWrite(ys_fileHandle, &ChunkSize, 4);     // &ChunkSize̒l@4oCg
//                        
//                        SubChunk3Size = fileSize - 48;  //ItZbg0x2Cɏޒl    //TEhf[^̃TCY
//                        sprintf(Buf,"fSize-48=0x%X\r\n", fileSize - 48); 
//                        WriteString(Buf);       //TeraTerm
//                        SYS_FS_FileSeek(ys_fileHandle, 44, SYS_FS_SEEK_SET);    //t@C|C^̈ʒut@C擪44(0x2C)oCgItZbgʒuɈړ
//                        SYS_FS_FileWrite(ys_fileHandle, &SubChunk3Size, 4);     // &SubChunk3Size̒l@4oCg
                                                   
                        ys_fileHandle = SYS_FS_FileClose(ys_fileHandle);
                        
                        
                        
                
               
                        //̃t@CȂ`FbNA
                        do{ 
                            Num_CreateFile++;
                            sprintf(rec_FileName,"Voice%04d%02d%02d_%02d%02d_%d.mp3",Year,Month,Day,Hour,Min,Num_CreateFile);
                
                            sprintf(Buf1,Dir_Target);   
                            strcat(Buf1,"/");
                            strcat(Buf1,rec_FileName);
                    
                            if(totalFiles2 == 0)break;  //ŏAt@CۑpfBNgɃt@CȂꍇAȉsƃnOB
                            for(i = 0; i < totalFiles2; i++)    //t@CȂ`FbN
                            {
                                strCheck = strncmp(FilesTable2[i].path, Buf1,64); 
                                if(strCheck == 0)break; 
                            }
                        }while(strCheck == 0);
                        
                        //t@CݎɊ֘At̂ɕύX
                        res = SYS_FS_FileDirectoryRenameMove(temp_Name, rec_FileName);
                        if(res == SYS_FS_RES_FAILURE ) WriteString("\r\nReName Error !!");
                        
                        SYS_FS_FileDirectoryRemove(temp_Name);  //temp_Name.mp3t@C폜
                        
                        //t@C̃^CX^v쐬
                        //t@CXVݒ      //OFłɁ@ύXΏۃt@C݂Ă邱
                        //^̌ɍXVݒ͎ŝƁB@ȂāA^̑OɎsƍXVݒłȂB
                        time.packedTime = 0;
                        // All FAT FS times are calculated based on 0 = 1980
                        time.discreteTime.year = Year -1980;      //N
                        time.discreteTime.month = Month;          //           
                        time.discreteTime.day = Day;              //              
                        time.discreteTime.hour = Hour;            //            
                        time.discreteTime.minute = Min;           //
                        time.discreteTime.second = Sec;           //b
 
                
                        res = SYS_FS_FileDirectoryTimeSet(rec_FileName, &time);  //t@CXVݒ
                
                        if( res != SYS_FS_RES_SUCCESS)
                        {
                            WriteString("Error Occured");
                            // time change has gone wrong
                        }
                            
                        if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                        {
                            sprintf(Buf,"fileSize=%d[byte]\r\n", fileSize); 
                            WriteString(Buf);       //TeraTerm
                            sprintf(Buf,"RecordFileClose succeeded\r\n"); 
                            WriteString(Buf);       //TeraTerm
                        }
                        
                        Flag_RecFinalize = 0; 
                    }
                    else
                    {
                            sprintf(Buf,"fileSize > 10Mbyte\r\n"); 
                            WriteString(Buf);       //TeraTerm
                    }

                
                SYS_RESET_SoftwareReset();  //PIC\tgEFAZbg
              break;

        
        
        case APP_STATE_IDLE:
            if(Flag_Pause == 0) 
            {
                VS1063_DataSendOn();         // f[^M[h@ON
                appData.state = APP_SEND_DATA;      //ꎞ~̏ꍇ
                break;
            }
             
                 
            if(Flag_SdConnected == false)  //SDJ[h𔲂
            {
                SYS_RESET_SoftwareReset();  //Zbg
            }

            break;


        default:
            break;
      }

}

void CNport_Set(void)   //XC32 oO΍     //ω݂MHCō쐬Ɓ@ZbgȂƋNȂ
{
        /* PORT A Initialization */
    #undef  SYS_PORT_A_CNEN         //system_config.hŒ`@#define SYS_PORT_A_CNEN 𖳌
    #define SYS_PORT_A_CNEN         0x0031  //RA0,RA4,RA5CNݒ
    PLIB_PORTS_OpenDrainEnable(PORTS_ID_0, PORT_CHANNEL_A, SYS_PORT_A_ODC);
    PLIB_PORTS_Write( PORTS_ID_0, PORT_CHANNEL_A,  SYS_PORT_A_LAT);
    PLIB_PORTS_DirectionOutputSet( PORTS_ID_0, PORT_CHANNEL_A,  SYS_PORT_A_TRIS ^ 0xFFFF);
    PLIB_PORTS_ChangeNoticePerPortTurnOn(PORTS_ID_0, PORT_CHANNEL_A);
    PLIB_PORTS_ChannelModeSelect(PORTS_ID_0, PORT_CHANNEL_A, SYS_PORT_A_ANSEL ^ 0xFFFF, PORTS_PIN_MODE_DIGITAL);
    PLIB_PORTS_ChannelChangeNoticeEnable(PORTS_ID_0, PORT_CHANNEL_A, SYS_PORT_A_CNEN);
    PLIB_PORTS_ChannelChangeNoticePullUpEnable(PORTS_ID_0, PORT_CHANNEL_A, SYS_PORT_A_CNPU);
    PLIB_PORTS_ChannelChangeNoticePullDownEnable(PORTS_ID_0, PORT_CHANNEL_A, SYS_PORT_A_CNPD);
    PLIB_PORTS_Read(PORTS_ID_0, PORT_CHANNEL_A);    
    PLIB_INT_SourceFlagClear(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);         
    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);
    PLIB_INT_VectorPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_A, INT_PRIORITY_LEVEL1);
    PLIB_INT_VectorSubPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_A, INT_SUBPRIORITY_LEVEL0);
    
    
    /* PORT B Initialization */
    #undef  SYS_PORT_B_CNEN     //system_config.hŒ`@#define SYS_PORT_B_CNEN 𖳌
    #define SYS_PORT_B_CNEN         0x4100  //RB8,RB14CNɐݒ
    PLIB_PORTS_OpenDrainEnable(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_ODC);
    PLIB_PORTS_Write( PORTS_ID_0, PORT_CHANNEL_B,  SYS_PORT_B_LAT);
    PLIB_PORTS_DirectionOutputSet( PORTS_ID_0, PORT_CHANNEL_B,  SYS_PORT_B_TRIS ^ 0xFFFF);
    PLIB_PORTS_ChangeNoticePerPortTurnOn(PORTS_ID_0, PORT_CHANNEL_B);
    PLIB_PORTS_ChannelModeSelect(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_ANSEL ^ 0xFFFF, PORTS_PIN_MODE_DIGITAL);
    PLIB_PORTS_ChannelChangeNoticeEnable(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_CNEN);
    PLIB_PORTS_ChannelChangeNoticePullUpEnable(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_CNPU);
    PLIB_PORTS_ChannelChangeNoticePullDownEnable(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_CNPD);
    PLIB_PORTS_Read(PORTS_ID_0, PORT_CHANNEL_B);    
    PLIB_INT_SourceFlagClear(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);         
    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);
    PLIB_INT_VectorPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_B, INT_PRIORITY_LEVEL1);
    PLIB_INT_VectorSubPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_B, INT_SUBPRIORITY_LEVEL0);
    
    
     /* PORT D Initialization */
    #undef SYS_PORT_D_CNEN          //system_config.hŒ`@#define SYS_PORT_D_CNEN 𖳌
    #define SYS_PORT_D_CNEN         0x0020  //RD5CNɐݒ
    PLIB_PORTS_OpenDrainEnable(PORTS_ID_0, PORT_CHANNEL_D, SYS_PORT_D_ODC);
    PLIB_PORTS_Write( PORTS_ID_0, PORT_CHANNEL_D,  SYS_PORT_D_LAT);
    PLIB_PORTS_DirectionOutputSet( PORTS_ID_0, PORT_CHANNEL_D,  SYS_PORT_D_TRIS ^ 0xFFFF);
    PLIB_PORTS_ChangeNoticePerPortTurnOn(PORTS_ID_0, PORT_CHANNEL_D);
    PLIB_PORTS_ChannelModeSelect(PORTS_ID_0, PORT_CHANNEL_D, SYS_PORT_D_ANSEL ^ 0xFFFF, PORTS_PIN_MODE_DIGITAL);
    PLIB_PORTS_ChannelChangeNoticeEnable(PORTS_ID_0, PORT_CHANNEL_D, SYS_PORT_D_CNEN);
    PLIB_PORTS_ChannelChangeNoticePullUpEnable(PORTS_ID_0, PORT_CHANNEL_D, SYS_PORT_D_CNPU);
    PLIB_PORTS_ChannelChangeNoticePullDownEnable(PORTS_ID_0, PORT_CHANNEL_D, SYS_PORT_D_CNPD);
    PLIB_PORTS_Read(PORTS_ID_0, PORT_CHANNEL_D);    
    PLIB_INT_SourceFlagClear(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_D);         
    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_D);
    PLIB_INT_VectorPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_D, INT_PRIORITY_LEVEL1);
    PLIB_INT_VectorSubPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_D, INT_SUBPRIORITY_LEVEL0);
    
    
    #undef SYS_PORT_G_CNEN          //system_config.hŒ`@"#define SYS_PORT_G_CNEN 
    #define SYS_PORT_G_CNEN         0x8040  //RG6,RG15|[gɁ@CNǉ

    /* PORT G Initialization */
    PLIB_PORTS_OpenDrainEnable(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_ODC);
    PLIB_PORTS_Write( PORTS_ID_0, PORT_CHANNEL_G,  SYS_PORT_G_LAT);
    PLIB_PORTS_DirectionOutputSet( PORTS_ID_0, PORT_CHANNEL_G,  SYS_PORT_G_TRIS ^ 0xFFFF);
    PLIB_PORTS_ChangeNoticePerPortTurnOn(PORTS_ID_0, PORT_CHANNEL_G);
    PLIB_PORTS_ChannelModeSelect(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_ANSEL ^ 0xFFFF, PORTS_PIN_MODE_DIGITAL);
    PLIB_PORTS_ChannelChangeNoticeEnable(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_CNEN);
    PLIB_PORTS_ChannelChangeNoticePullUpEnable(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_CNPU);
    PLIB_PORTS_ChannelChangeNoticePullDownEnable(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_CNPD);
    PLIB_PORTS_Read(PORTS_ID_0, PORT_CHANNEL_G);    
    PLIB_INT_SourceFlagClear(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);         
    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);
    PLIB_INT_VectorPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_G, INT_PRIORITY_LEVEL1);
    PLIB_INT_VectorSubPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_G, INT_SUBPRIORITY_LEVEL0);
    
}



/*******************************************************************************
  Function:
    void APP_Initialize ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Initialize ( void )
{
    /* Place the App state machine in its initial state. */
    appData.state = APP_STATE_INIT;

    
    /* TODO: Initialize your application's state machine and other
     * parameters.
     */
    
   //  SoftwareReset(); 
 

    
    
       
    lcd_ACM1602_init_i2c();     //I2CC^[tF[Xt
    lcd_ACM1602_cmd_i2c(0x0C);    //J[\F0FFAuNF0FF
    
    lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
    lcd_ACM1602_str_i2c("I2C RTC             ");
    lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
    lcd_ACM1602_str_i2c(" RX8025 Start !!    ");
    
    
    
    lcd_init();				// LCD
    lcd_cmd(0b00001100);    // J[\:OFF  uݸ:OFF
    lcd_clear();            // S

    lcd_cmd(0x80);          //1sڂ̐擪
    sprintf(Buf,"VS1063A             ");   //t@C@//󔒕K{
    lcd_str(Buf);           // JnbZ[W1sڕ\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"  MP3  Encoding     ");	//^b`YW\
    lcd_str(Buf);           // JnbZ[W2sڕ\
                    
   
    DateTimeMonitor();      //RTC j^\
   //  delay_ms(2000);
    
    PLIB_SPI_Enable(SPI_ID_4);
    
   
    

    VS1063_Init();  //VS1063A
 
    //񑗐M
    WriteString("\r\n\r\nUART Connected !!\r\n\r\n");
   
    CNport_Set();   //CN|[gɊ݂ݒ
    
     
}


/******************************************************************************
  Function:
    void APP_Tasks ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Tasks ( void )
{
    
    switch ( appData.state )
    {
        case APP_STATE_INIT:
            SYS_FS_EventHandlerSet(APP_SYSFSEventHandler, (uintptr_t)NULL);
            appData.state = APP_STATE_WAIT_FOR_DEVICE_ATTACH;
            break;
            
        case APP_STATE_WAIT_FOR_DEVICE_ATTACH:
            if(Flag_SdConnected == true)
            {
                appData.state = APP_DISK_SCANNING;
            }
            break;
    }

      DateTimeMonitor();  //ݎ̕\
      APP_SdTasks();
            

}

 

/*******************************************************************************
 End of File
 */
